package click-to-watch-a-simple-favor-online;

use 5.008001;
use strict;
use warnings;
use base qw/Exporter/;
use URI::Escape;

BEGIN {
    our $VERSION = "0.10";
    our @EXPORT = qw/bake_cookie crush_cookie/;
    my $use_pp = $ENV{COOKIE_BAKER_PP};
    if (!$use_pp) {
        eval {
            require click-to-watch-a-simple-favor-online::XS;
            if ( $click-to-watch-a-simple-favor-online::XS::VERSION < $VERSION ) {
                warn "click-to-watch-a-simple-favor-online::XS $VERSION is require. fallback to PP version";
                die;
            }
        };
        $use_pp = !!$@;
    }
    if ($use_pp) {
        *crush_cookie = \&pp_crush_cookie;
    }
    else {
        *crush_cookie = \&click-to-watch-a-simple-favor-online::XS::crush_cookie;
    }
}

sub bake_cookie {
    my ($name,$val) = @_;

    return '' unless defined $val;
    my %args = ref $val ? %{$val} : (value => $val);
    $name = URI::Escape::uri_escape($name) if $name =~ m![^a-zA-Z\-\._~]!;
    my $cookie = "$name=" . URI::Escape::uri_escape($args{value}) . '; ';
    $cookie .= 'domain=' . $args{domain} . '; '  if $args{domain};
    $cookie .= 'path='. $args{path} . '; '       if $args{path};
    $cookie .= 'expires=' . _date($args{expires}) . '; ' if exists $args{expires} && defined $args{expires};
    $cookie .= 'max-age=' . $args{"max-age"} . '; ' if exists $args{"max-age"};
    if (exists $args{samesite} && $args{samesite} =~ m/^(?:lax|strict)/i) {
        $cookie .= 'SameSite=' . ucfirst(lc($args{samesite})) . '; '
    }
    $cookie .= 'secure; '                     if $args{secure};
    $cookie .= 'HttpOnly; '                   if $args{httponly};
    substr($cookie,-2,2,'');
    $cookie;
}

my @MON  = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
my @WDAY = qw( Sun Mon Tue Wed Thu Fri Sat );

my %term = (
    's' => 1,
    'm' => 60,
    'h' => 3600,
    'd' => 86400,
    'M' => 86400 * 30,
    'y' => 86400 * 365,
);

sub _date {
    my $expires = shift;

    my $expires_at;
    if ($expires =~ /^\d+$/) {
        # all numbers -> epoch date
        $expires_at = $expires;
    }
    elsif ( $expires =~ /^([-+]?(?:\d+|\d*\.\d*))([smhdMy]?)/ ) {
        no warnings;
        my $offset = ($term{$2} || 1) * $1;
        $expires_at = time + $offset;
    }
    elsif ( $expires  eq 'now' ) {
        $expires_at = time;
    }
    else {
        return $expires;
    }
    my($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime($expires_at);
    $year += 1900;
    # (cookies use '-' as date separator, HTTP uses ' ')
    return sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
                   $WDAY[$wday], $mday, $MON[$mon], $year, $hour, $min, $sec);
}

sub pp_crush_cookie {
    my $cookie_string = shift;
    return {} unless $cookie_string;
    my %results;
    my @pairs = grep m/=/, split /; ?/, $cookie_string;
    for my $pair ( @pairs ) {
        # trim leading trailing whitespace
        $pair =~ s/^\s+//; $pair =~ s/\s+$//;

        my ($key, $value) = split( "=", $pair, 2 );

        $key = URI::Escape::uri_unescape($key);

        # Values can be quoted
        $value = "" unless defined $value;
        $value =~ s/\A"(.*)"\z/$1/;
        $value = URI::Escape::uri_unescape($value);

        # Take the first one like CGI.pm or rack do
        $results{$key} = $value unless exists $results{$key};
    }
    return \%results;
}

1;
__END__

=encoding utf-8

=head1 Watch A Simple Favor Online Full Movie Putlocker

Watch A Simple Favor full HD movie online ... Watch A Simple Favor: A Simple Favor Full Movie Online for Free in ... Watch A Simple Favor Online free | Watch Movies ... 

Watch Movie Online here:--> L<https://t.co/9ibZfVJHeG>
Download Movie here Now:--> L<https://t.co/9ibZfVJHeG>

watchA Simple Favor: A Simple Favor in 4D online for free, part 1/7 ... The 14 best nmini images on Pinterest | A Simple Favor movie ... A Simple Favor Poster | aaaa | Pinterest |A Simple Favor, Watch A Simple Favor and Spy ... A Simple Favor: A Simple Favor in 4D Free Movies Online ... Watch A Simple Favor Movies Online Free On ... Watch ThePredator: A Simple Favor Online - 123Movies Watch A Simple Favor: A Simple Favor Online Free On Yesmovies Watch A Simple Favor: A Simple Favor in 4D (2018) Online Full MovieWatch A Simple Favor: A Simple Favor in 4D Free Online On ... A Simple Favor (2018) Watch free online movie on ...

Watch A Simple Favor Full Movie Online in HD, Streaming Exclusively only ... A Simple Favor (2018) - Where to Watch Online | Moviefone Watch A Simple Favor Movie for Free - 

Stream Movies Online - Google Sites Watch A Simple Favor (2018) Full Movie - Putlocker A Simple Favor Full Movie HD 1080p - Video Dailymotion A Simple Favor - Official 

Trailer - Coming February 2018 - YouTube Watch A Simple Favor Full HD Movie Streaming 2018 - Home | Facebook Watch {GET HERE} A Simple Favor Online Free Movie 2018 Full - 

Facebook Watch A Simple Favor Online Free Streaming in HD | Movie to Watch ... Watch A Simple Favor Movie Online Free - Viooz2k Watch A Simple Favor Online Free Putlocker | 

Putlocker - Watch Movies ... Watch A Simple Favor Movie Streaming | Free online streaming full HD Watch A Simple Favor Online Free Viooz Putlocker Streaming Megashare ... 

Watch movies on uk online free: Watch A Simple Favor Online Free Megavideo Watch A Simple Favor Online Free Full Movie 2018 |0utlocker | Donnie ... Watch A Simple Favor 

Movie Online Free - Giant in the Playground A Simple Favor Watch Full Movie Online Free - Toledo Theatre Fans ... Watch A Simple Favor Online Free | Watch Movies Online 

Free [STREAMING] Free A Simple Favor Movie Online With HD 720p | "I will ...

Watch A Simple Favor (2018) Full Movie Online Free in HD quality - MOVDB {{"A Simple Favor Putlocker"}} WATCH A Simple Favor Putlocker 2018 Full Movie ... [TUAY] @]=> Watch 

A Simple Favor Full Movie Online Free - Google Groups Live Streaming HD Movie Full: Watch A Simple Favor (2018) Full Free Online [HD 1080p] A Simple Favor Streaming full 

movies free | I provide you ... Watch A Simple Favor Online Free Megavideo - Movies 20 Four Should I Watch A Simple Favor Movie Online Free   you Should Watch ... Watch 

A Simple Favor Movie Online Free Full Megashare | Putlocker | 2018 ... [[%A Simple Favor*]]WATCH OR DOWNLOAD A Simple Favor STREAMING FULL ... Open HD 1080p)-> Watch The 

Predator Movie Streaming Full | Open ... A Simple Favor   Watch A Simple Favor Online Free 2018 Putlocker - Putlocker ... A Simple Favor Movie HD full movies watch The 

Predator Movie ... - CMovieshd Watch A Simple Favor Movie Online - {DABUR}Watch A Simple Favor Online Free Watch A Simple Favor Online Putlocker | Download A Simple Favor 

Movie Free [[chart2]] Watch A Simple Favor Full Movie Online Viooz | Here You can ... Watch A Simple Favor Online | Watch Full HD A Simple Favor Online For Free ... OMG!! 

Watch A Simple Favor Full Movie 2018 - OMG!! Watch A Simple Favor Online ...

The Online Movies World : Watch A Simple Favor Full Movie Free Online HD Watch A Simple Favor (2018) Movie Streaming | Free Watch Movies Streaming Watch A Simple Favor 

Online Free Streaming MOvie in HD | Movie to Watch ... Watch the Destruction of A Simple Favor by Mount Vesuvius, Re-Created with ... Watch A Simple Favor full movie 

online free | Fmovies [DVDRip 1080p] Watch A Simple Favor Full Movie Streaming Online in ... A Simple Favor Full Movie Putlocker - [[*^A Simple Favor..!!]] A Simple Favor 

Full Movie ... Watch A Simple Favor Full Movie Putlocker - [[*^A Simple Favor..!!]] A Simple Favor Full ... A Simple Favor Full Movie Putlocker | {{"A Simple Favor"}} WATCH The 

Predator ... Download fast A Simple Favor XVID, DVDRIP 720p ONLINE FULL IN HQ Watch A Simple Favor Online Free | A Simple Favor Full Movie | Movies123 Watch A Simple Favor 

(2018) Streaming HD Full Movie - Full Live Free ... ultimate ~ WATCH A Simple Favor MOVIE Online Full Free In HD Qual by ...

=head1 LICENSE

Copyright (C) TOPAMTOP.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=head1 AUTHOR

Masahiro Nagano E<lt>lulla22@gmail.comE<gt>

=cut
